# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%global short_name scout

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define maven_version 1.2.6-redhat-1

Name:           ws-scout
Version:        1.2.6
Release:        2%{?reltag}.2%{?dist}
Epoch:          0
Summary:        Apache Scout Implementation of JSR 93 (JAXR)
License:        ASL 2.0
Group:          Text Processing/Markup/XML

%if %with mead
Source100: org.apache.juddi.scout-scout-1.2.6-redhat-1-sources.zip
Source101: org.apache.juddi.scout-scout-1.2.6-redhat-1-patches.zip
Source102: scout-1.2.6-redhat-1-javadoc.jar
Source103: scout-1.2.6-redhat-1-sources.jar
Source104: scout-1.2.6-redhat-1.jar
Source105: scout-1.2.6-redhat-1.pom
%endif

URL:            http://ws.apache.org/scout/
%if 0
svn -q export -r 1295391 https://svn.apache.org/repos/asf/juddi/scout/tags/scout-1.2.6/ ws-scout-1.2.6 && tar cjf ws-scout-1.2.6.tar.bz2 ws-scout-1.2.6
%endif
%if %without mead
Source0:        ws-scout-1.2.5.tar.bz2
Source1:        ws-scout-jpp-depmap.xml
Patch0:         ws-scout-vman-pom.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildRequires:  cargo-maven2-plugin
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-shade-plugin
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared
BuildRequires:  maven-shared-file-management
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-wagon
BuildRequires:  plexus-archiver
BuildRequires:  plexus-compiler
BuildRequires:  plexus-containers-container-default
BuildRequires:  plexus-i18n
BuildRequires:  plexus-utils
BuildRequires:  plexus-velocity
BuildRequires:  maven-bundle-plugin

BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management
BuildRequires:  derby
BuildRequires:  glassfish-jaxb
BuildRequires:  jboss-jaxb-api_2.2_spec
BuildRequires:  jboss-jaxr-api_1.0_spec
BuildRequires:  jboss-jaxrpc-api_1.1_spec
BuildRequires:  jboss-saaj-api_1.3_spec
BuildRequires:  stax_1_0_api
BuildRequires:  jakarta-commons-discovery
BuildRequires:  jakarta-commons-logging
BuildRequires:  jdom
BuildRequires:  juddi 
BuildRequires:  junit
BuildRequires:  aspectj
BuildRequires:  log4j
BuildRequires:  wsdl4j
# FIXME: Needed by hamcrest, indirect dependency
BuildRequires:  jmock
Requires:  glassfish-jaxb
Requires:  jboss-jaxb-api_2.2_spec
Requires:  jboss-jaxr-api_1.0_spec
Requires:  jboss-jaxrpc-api_1.1_spec
Requires:  jboss-saaj-api_1.3_spec
%endif

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Scout is an implementation of the 
JSR 93 (JAXR). 

%package javadoc
Summary:        Javadoc for scout
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
Javadoc for scout.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 
%{__rm} src/main/java/org/apache/ws/scout/transport/AxisTransport.java
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
#%{_bindir}/mvn-jpp -e -P '!uddiv2,uddiv3' -DskipTests=true -Dmaven2.jpp.depmap.file=%{SOURCE1} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip=true deploy javadoc:aggregate
%{_bindir}/mvn-jpp -e -Dmaven2.jpp.depmap.file=%{SOURCE1} -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip=true deploy javadoc:aggregate
%endif

%install
rm -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/scout-%{namedversion}.jar %{buildroot}%{_javadir}/scout-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/scout-%{namedversion}.jar %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/scout-%{namedversion}-sources.jar %{buildroot}%{_javadir}
%endif

(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-scout.pom
%else
%{__cp} -p %{_sourcedir}/scout-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-scout.pom
%endif

# depmaps
%add_to_maven_depmap org.apache.ws.scout scout %{namedversion} JPP scout
[ "%{name}" = "scout" ] || mv %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/scout

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/scout-%{namedversion}
%if %without mead
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/scout-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/scout-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/scout-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/scout-%{namedversion}/META-INF
%endif
ln -s scout-%{namedversion} %{buildroot}%{_javadocdir}/scout

%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
cp -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc KEYS LICENSE NOTICE README
%{_javadir}*/scout-%{namedversion}.jar
%{_javadir}*/scout.jar
%else
%{_javadir}*/scout-%{namedversion}.jar
%{_javadir}*/scout.jar
%{_javadir}*/scout-%{namedversion}-sources.jar
%{_javadir}*/scout-sources.jar
%endif
%{_mavenpomdir}/JPP-scout.pom
%{_mavendepmapfragdir}/scout

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/scout-%{namedversion}
%{_javadocdir}/scout

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri May 25 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.6-2.redhat_1.2
- Clean MANIFEST

* Thu Mar 29 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.2.6-1_redhat_1.2
- Rebuild to remove dependency on stax

* Wed Mar 28 2012 Hui Wang <huwang@redhat.com> 0:1.2.6-1_redhat_1.1
- Upgrade to 1.2.6

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.5-1_redhat_1.3.1
- Rebuild using cache signing

* Thu Mar 15 2012 Fernando Nasser <fnasser@redhat.com> 0:1.2.5-1_redhat_1.3
- Require jmock, needed by hamcresst (indirect dependency, brought by junit)

* Thu Mar 15 2012 Fernando Nasser <fnasser@redhat.com> 0:1.2.5-1_redhat_1.2
- Remove stax as a run-time dependency, it is in the JRE
- Remove juddi as a run-time dependency, this is a client to that server

* Wed Feb 29 2012 Hui Wang <huwang@redhat.com> 0:1.2.5-1_redhat_1.1
- Upgrade to 1.2.5
- Adjust BR/R

* Tue Feb 07 2012 Fernando Nasser <fnasser@redhat.com> 0:1.2.3-0.1.1
- Do not require axis at run-time

* Thu Dec 15 2011 David Walluck <dwalluck@redhat.com> 0:1.2.3-0.1
- 1.2.3
- disable axis
- patch pom
- fix Requires based on dependencies in pom
- fix file locations
- use real maven deploy
- remove codehaus-stax11-api (in JDK)
- fix maven deps
- fix repolib file ownership

* Fri Jan 21 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.1.1-3.4.3
- Fix groupId to apache-scout for proper repolib content
- Fix packaging for uploading script

* Wed Dec 01 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.1-3.4.2
- Build with Maven 2.2.1
- Change BR maven2-plugin-shade to maven-shade-plugin
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR mavne-deploy-plugin
- Add the line to find and remove any binaries
- Add BR codehaus-stax11-api

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-3.4.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.1.1-3.4
- Rebuild

* Mon Mar 22 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.3
- enable axis support at build time

* Thu Feb 25 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.2
- bump release

* Thu Feb 25 2010 David Walluck <dwalluck@redhat.com> 0:1.1.1-3.1
- make axis optional
- fix jpackage-utils Requires
- fix component-info.xml
- remove BuildRoot in install

* Fri Nov 20 2009 Martha Benitez <mbenitez@redhat.com> 0:1.1.1-3
- Add repolib

* Wed Nov 04 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.1-2
- Patch pom so it works (more or less) with older versions of the bundle plugin

* Mon Aug 24 2009 Fernando Nasser <fnasser@redhat.com> 0:1.1.1-1
- Upgrade to 1.1.1

* Thu May 21 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0-5.1
- Change jpackage-utils >= 0:1.6 to jpackage-utils >= 0:1.3

* Wed Jul 09 2008 Fernando Nasser <fnasser@redhat.com> 0:1.0-5
- Saxon-scripts is required for building

* Mon Feb 13 2006 Ralph Apel <r.apel@r-apel.de> 0:1.0-4jpp
- Switch to require jaf, as provided by geronimo-specs

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:1.0-3jpp
- First JPP 1.7 build

* Wed Aug 17 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-2jpp
- Improve multiproject treatment *THIS CHANGE MAY HAVE BEEN LOST IN THE MERGE*

* Tue Jul 26 2005 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp_2rh
- Removed the log4j.properties file (may cause problems with other packages).

* Tue Jul 26 2005 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp_1rh
- First Red Hat build.
- Update to use maven-1.0.2 (and it's symlink to /usr/share/java in the repo).
- Removed spurious dependencies.
- Use generic activation jar instead of the geronimo-sandbox one.

* Tue Jul 26 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-1jpp
- First JPackage release
